﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Grids;
using Infragistics.Windows.Editors;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public decimal MyValue { get; set; }

        public RowDataCollection Rows { get; set; }

        public MainWindow()
        {
            Rows = new RowDataCollection();
            this.DataContext = this;

            InitializeComponent();
            this.Loaded += MainWindow_Loaded;
        }

        void MainWindow_Loaded(object sender, RoutedEventArgs e)
        {
            int numColumns = Rows[0].Price.Length;
            for (int i = 0; i < numColumns; i++)
            {
                // Pricing column
                var display = new FrameworkElementFactory(typeof(TextBlock));
                var binding = new Binding("Price[" + i + "]");
                binding.StringFormat = "{0:C}";
                display.SetBinding(TextBlock.TextProperty, binding);
                var dollarCellDisplay = new DataTemplate() { VisualTree = display };
                dollarCellDisplay.Seal();

                var editor = new FrameworkElementFactory(typeof(XamCurrencyEditor));
                binding = new Binding("Price[" + i + "]");
                editor.SetBinding(XamCurrencyEditor.ValueProperty, binding);
                var dollarCellEditor = new DataTemplate() { VisualTree = editor };
                dollarCellEditor.Seal();

                TemplateColumn priceColumn = new TemplateColumn()
                {
                    Key = "Price[" + i + "]",
                    HeaderText = "S" + i,
                    HorizontalContentAlignment = HorizontalAlignment.Right,
                    VerticalContentAlignment = VerticalAlignment.Center,
                    IsReadOnly = false,
                    ItemTemplate = dollarCellDisplay,
                    EditorTemplate = dollarCellEditor,
                    Width = new ColumnWidth(80.0D, false)
                };

                xamGrid1.Columns.Add(priceColumn);
            }
        }

        private void XamCurrencyEditorGotFocus(object sender, RoutedEventArgs e)
        {

        }
    }

    public class RowData
    {
        public decimal?[] Price { get; set; }
    }

    public class RowDataCollection : ObservableCollection<RowData>
    {
        public RowDataCollection()
        {
            Add(new RowData { Price = new decimal?[] { 1.0M, 2.0M, 3.0M, null } });
            Add(new RowData { Price = new decimal?[] { 1.0M, null, 3.0M, 4.0M } });
            Add(new RowData { Price = new decimal?[] { 1.0M, 2.0M, null, 4.0M } });
        }
    }

    public class SampleDataItem
    {
        public string name { get; set; }
        public string department { get; set; }
        public decimal? salary { get; set; }
        public string email { get; set; }
    }

    public class SampleData : ObservableCollection<SampleDataItem>
    {
        public SampleData()
        {
            Add(new SampleDataItem { name = "Joe", department = "Sales", salary = 70000.0M, email = "joe@email.com" });
            Add(new SampleDataItem { name = "Mary", department = "Engineering", salary = 71000.0M, email = "mary@email.com" });
            Add(new SampleDataItem { name = "Jim", department = "Sales", salary = 72000.0M, email = "jim@email.com" });
        }
    }
}
